PGraphics Main, Camxy, Joy, Status;
PImage barra, rotacao, mouse, seta, mouseL, lupa, arrows;
PFont verd, verdS, verdSS;

Button credits, teoria, next, prev, controls, controlst, maisinfo;

float ro, fi, th, ancX, ancY, focX, focY;
int roamW, roamH;                          // cam roam window
int joyRad, joyX, joyY;
float jX, jY, joyMod;
int lightsmode;

int statW, statH, gradH;
int teo;
int dd;  // redraw int
PVector vC;

float mx, my;
float tx, ty;
boolean locked1, locked2, locked3, locked4, mpress, mdrag;    // 1=main 2=roam 3=joystick

int Npil = 1300;
P[] p = new P[Npil];

void setup ()
{
  smooth();

  frameRate (30);
  size (720,600);
  roamW=140;
  roamH=120;

  statW=width;
  statH=20;
  gradH=20;

  joyRad=60;
  joyX=width-joyRad;
  joyY=height-statH-joyRad-40;
  locked1=locked2=locked3=locked4=mpress=false;

  // mouse wheel trickery
  addMouseWheelListener(new java.awt.event.MouseWheelListener() { 
    public void mouseWheelMoved(java.awt.event.MouseWheelEvent evt) { 
      mouseWheel(evt.getWheelRotation());
    }
  }
  ); 

  lid=1;

  //FONTES
  verd = loadFont ("Verdana-20.vlw");
  verdS = loadFont ("Verdana-15.vlw");
  verdSS = loadFont ("Verdana-8.vlw");

  //PGRAPHICS
  Camxy = createGraphics (roamW, roamH, P2D);
  Status = createGraphics (statW, statH, P2D);
  Joy = createGraphics (2*joyRad, 2*joyRad, P3D);
  Main = createGraphics (width, height, P3D);

  //CAMERA VARS
  ro=3500;
  th=PI;
  fi=0.7;
  focX=1200;//width/2;
  focY=1200;//height/2;

  mx=roamW/2;
  my=roamH/2;

  vC= new PVector (0,0,0);      // camera pointing vector

  // INICIALIZACAO PILINDROS
  iniPilindros();      // inicializa polindros mapeados


    // INICIALIZACAO BARRA STATUS

  barra = createImage (720, 50, ARGB);
  barra.loadPixels();
  for (int y = 0; y < barra.height; y++) {
    for (int x = 0; x < barra.width; x++) {
      int loc = x + y*width;
      barra.pixels[loc] = color(200,240,255,float(y)/barra.height*300);
    }
  }
  barra.updatePixels();
  teo=1;

  metalog=loadImage("metalog1.jpg");
  plogo = loadImage ("plogo.png");
  rotacao = loadImage ("rotation.png");
  seta = loadImage ("arrow.png");
  mouse = loadImage ("mouses.png");
  mouseL = loadImage ("mouse.png");
  lupa = loadImage ("lupa.png");
  arrows = loadImage ("arrows.png");

  //BOTOES
  teoria  = new Button (g, 0, 0, 90, height-20, 140, 30, "Teoria", "Voltar", color (80,150,230,100));
  credits = new Button (g, 0, 0, width-90, height-20, 140, 30, "Créditos", "Voltar", color (80,150,230,100));
  controls= new Button (g, 0, 0, width/2, height-20, 140, 30, "Controles", "Voltar", color (80,150,230,100));
  next  = new Button (g, 0.1*width, 0.1*height-15, 500, 455, 40, 30, ">>", ">>", color (100,100));
  prev  = new Button (g, 0.1*width, 0.1*height-15, 80, 455, 40, 30, "<<", "<<", color (100,100));
  controlst = new Button (g, 0.1*width, 0.1*height-15,w/4-10,450, 120, 25, "Controles", "Fechar", color (50,255,10,100));
  maisinfo = new Button (g, 0.2*width, 0.2*height-15,w/2-115,475, 140, 30, "+ info", "- info", color (50,255,10,100));

  // LIGHTS MODE
  lightsmode=0;
}









void draw()
{ 

  //!!! println(frameCount +"//"+ fi);
  //println (ancX+" "+ancY+" // "+focX+" "+focY);
  //println (th+" "+fi);

  Main.beginDraw();
  Main.background (0);

  // CAMERA CONTROLS

  //camera(mouseX,  mouseY,10, width/2, height/2, 0, 0, 0, -1); //eyeX, eyeY, eyeZ, centerX, centerY, centerZ, upX, upY, upZ
  Main.camera(focX+ro*cos(th)*sin(fi), focY+ro*sin(th)*sin(fi), ro*cos(fi), focX, focY, 0, 0, 0, -sin(fi)); 
  vC.set(ro*cos(th)*sin(fi), ro*sin(th)*sin(fi), ro*cos(fi));    // vetor visao da camera

  // LIGHTS CONTROLS
  if (lightsmode==0)
  {
    Main.lights();
    Main.pointLight (80,80,80,focX+ro*cos(th)*sin(fi), focY+ro*sin(th)*sin(fi), ro*cos(fi));
  }
  if (lightsmode==1) 
    Main.spotLight(250,250,250,focX+ro*cos(th)*sin(fi), focY+ro*sin(th)*sin(fi), ro*cos(fi), -cos(th)*sin(fi), -sin(th)*sin(fi), -ro*cos(fi), PI/2, 1);
  if (lightsmode==2) 
    Main.pointLight (255,255,255,focX+ro*cos(th)*sin(fi), focY+ro*sin(th)*sin(fi), ro*cos(fi));



  // PILINDROS CONTROLS
  for (int i=0; i<1300; i++)
    p[i].draw();

  //println ((ancX+ro*cos(th)*sin(fi)) +","+ (ancY+ro*sin(th)*sin(fi)));

  /*triad
   Main.translate(0,0,20);
   Main.stroke(0,0,255);
   Main.line (0,0,0,0,0,20);
   Main.stroke(0,255,0);
   Main.line (0,0,0,0,20,0);
   Main.stroke(255,0,0);
   Main.line (0,0,0,20,0,0);
   Main.stroke(50);
   
   */

  Main.endDraw();
  image (Main,0,0);

  // CAM TRANSLATION WINDOW CONTROLS

  Camxy.beginDraw();
  Camxy.background(0,70,200,180);
  north(th);
  mx = constrain(mx, 1, roamW-1);
  my = constrain(my, 1, roamH-1);
  Camxy.stroke(255);
  Camxy.strokeWeight(2);
  Camxy.translate (mx, roamH-my);
  Camxy.line (-5, 0, 5, 0);
  Camxy.line (0,-5, 0, 5);
  Camxy.endDraw();
  image (Camxy, width-roamW, 0);  


  // JOYSTICK CONTROLS

  if (mpress && mdrag && locked3 && mousePressed && mouseButton==LEFT)
  {
    println ((mouseX-joyX)*(mouseX-joyX)+(mouseY-joyY)*(mouseY-joyY));

    joyMod=(mouseX-joyX)*(mouseX-joyX)+(mouseY-joyY)*(mouseY-joyY);

    if (joyMod<(joyRad-10)*(joyRad-10))
    {
      jX=(mouseX-joyX+joyRad);
      jY=(mouseY-joyY+joyRad);
    }
    else
    {

      jX=(mouseX-joyX)/sqrt(joyMod)*(joyRad-10)+joyRad;
      jY=(mouseY-joyY)/sqrt(joyMod)*(joyRad-10)+joyRad;
    }

    tx=(mouseX-joyX)*50/joyRad;
    ty=-(mouseY-joyY)*50/joyRad;
    incCam(tx, ty);
  }
  else
  { 
    jX=(joyRad);
    jY=(joyRad);
  }


  Joy.beginDraw();
  Joy.noStroke();
  Joy.background(255,1);
  Joy.fill(50,160,255); // joy color
  Joy.ellipse(joyRad, joyRad, 2*joyRad, 2*joyRad);
  Joy.fill(110,200,255);
  Joy.stroke(110,200,255,180);
  Joy.strokeWeight(10);
  Joy.line (joyRad, joyRad, jX, jY);
  Joy.noStroke();
  Joy.ellipse(jX,jY,20,20);
  Joy.ellipse(joyRad, joyRad,10,10);
  Joy.endDraw();

  tint (255,150); // trickery
  image (Joy, joyX-joyRad, joyY-joyRad);  
  noTint();



  // STATUS BAR MANAGEMENT
  image (barra, 0, height-barra.height);
  if (!credits.isSelected() && !controls.isSelected()) teoria.display();
  if (!teoria.isSelected() && !controls.isSelected())  credits.display();
  if (!credits.isSelected() && !teoria.isSelected())   controls.display();


  if (credits.isSelected())
  {
    showCredits();
  }

  //TEORIA MANAGEMENT
  if (teoria.isSelected())
  {
    showTeoria();
  }
  else if (!maisinfo.isSelected()) teo=1;

  // CONTROLS MANAGEMENT
  if (controls.isSelected())
  {
    showControls();
  }
  else maisinfo.unSelect();
  if (controlst.isSelected())
  {
    showControls();
  }
  if (maisinfo.isSelected())
  {
    teo=4;
    showTeoria();
  }

  if (dd<1 && !mpress)
    noLoop();
  else
    dd--;
}


//CAMERA CONTROLS 

void incCam (float dx, float dy)
{
  mx += (-sin(th)*dy-cos(th)*dx)/17.2;
  my += (-cos(th)*dy+sin(th)*dx)/20;

  focY += -sin(th)*dy-cos(th)*dx;
  focX += -cos(th)*dy+sin(th)*dx;

  if (focX<=0) focX=0;
  if (focX>=2400) focX=2400;
  if (focY<=0) focY=0;
  if (focY>=2400) focY=2400;
}

void translateCam(float mmx, float mmy)
{
  //println (mmx/roamW+" "+mmy/roamH);

  mmx = constrain(mmx, 1, roamW-1);
  mmy = constrain(mmy, 1, roamH-1);

  focX = map (mmy, 1, roamH-1, 0,2400);
  focY = map (mmx, 1, roamW-1, 0,2400);

  //println (focX+" "+focY);
}

void north (float z)
{
  int p=5;
  Camxy.pushMatrix();
  Camxy.pushStyle();
  Camxy.fill(0,150);
  Camxy.noStroke();
  Camxy.translate(roamW/2, roamH/2);
  Camxy.rotate(z);
  Camxy.beginShape();
  Camxy.vertex (0,4*p);
  Camxy.vertex (3*p,0);
  Camxy.vertex (1.5*p,0);
  Camxy.vertex (1.5*p,-4*p);
  Camxy.vertex (-1.5*p,-4*p);
  Camxy.vertex (-1.5*p,0);
  Camxy.vertex (-3*p,0);
  Camxy.endShape(CLOSE);
  Camxy.popMatrix();
}


// THREADS
void mouseDragged ()
{ 

  mdrag=true;
  //println(sqrt((mouseX-joyX)*(mouseX-joyX)+(mouseY-joyY)*(mouseY-joyY)));

  // se estiver no quadradinho, e nao estiver locked nos outros
  if ((mouseX>width-roamW && mouseY<roamH || locked2) && !locked1 && !locked3)                                             // camera translation window
  {
    if (mousePressed && mouseButton == LEFT)
    {
      locked2=true;
      mx=mouseX-(width-roamW);
      my=roamH-mouseY;
      translateCam(mx, my);
    }
  }
  else if (sqrt((mouseX-joyX)*(mouseX-joyX)+(mouseY-joyY)*(mouseY-joyY))<joyRad && !locked1 && !locked2)
  {
    locked3=true;
  }
  else if (!locked1 && !locked2 && !locked3 && mouseY>height-barra.height)
  {
    locked4=true;
  }
  // (se não estiver no quadradinho ou estiver locked1) E se nao estiver locked nos outros

  else if (!locked2 && !locked3 && !locked4 && (!teoria.isSelected() || !(mouseX>0.1*width && mouseX<0.9*width && mouseY>0.1*height-15 && mouseY<0.9*height-15) || (mousePressed && mouseButton==RIGHT)  ))      // normal camera rotation
  {
    float ratio;
    locked1=true;
    if (ro>300) ratio=ro;
    else ratio=300;
    th+=TWO_PI*(mouseX-pmouseX)/float(width)*ratio/1800;
    fi+=-TWO_PI*(mouseY-pmouseY)/float(height)*ratio/1800;
  }
  //else 

  dd=2;
  loop();
}

void mousePressed()
{
  mouseDragged();
  // if (credits.isSelected() ) credits.unSelect(); ta dando problema na volt
  mpress=true;

  // RESETS DE RIGHT CLICK
  loop();
  if ((mouseX>width-roamW && mouseY<roamH) && mousePressed && mouseButton==RIGHT) { 
    th=PI; 
    fi = 0.7;
  }
  if (((mouseX-joyX)*(mouseX-joyX)+(mouseY-joyY)*(mouseY-joyY)<joyRad*joyRad) && mousePressed && mouseButton==RIGHT) { 
    focX=focY=1200; 
    mx=roamW/2; 
    my=roamH/2;
  }

  // buttons mousepressed method

  if (!credits.isSelected() && !controls.isSelected()) teoria.mousePressed(mouseX,mouseY);
  if (!teoria.isSelected() && !controls.isSelected())  credits.mousePressed(mouseX,mouseY);
  if (!credits.isSelected() && !teoria.isSelected())   controls.mousePressed(mouseX,mouseY);
  if ((teoria.isSelected() && teo==4))   controlst.mousePressed(mouseX,mouseY);
  if (controls.isSelected())   maisinfo.mousePressed(mouseX,mouseY);
  next.mousePressed(mouseX,mouseY);
  prev.mousePressed(mouseX,mouseY);

  //if (teoria.isSelected() && mousePressed && (mouseButton == LEFT))
  //teo++;
  //if (!teoria.isSelected()) teo=1;
}

void mouseReleased ()
{
  locked1=false;
  locked2=false;
  locked3=false;
  locked4=false;
  mpress=false;
  mdrag=false;


  // buttons mousereleased method
  teoria.mouseReleased();
  credits.mouseReleased();
  controls.mouseReleased();
  controlst.mouseReleased();
  next.mouseReleased();
  prev.mouseReleased();
  maisinfo.mouseReleased();

  dd=2;
  loop();
}


void keyPressed ()
{ 
  if (key==CODED)
  {
    println("))))"+keyCode);
    
    if (keyCode==UP) { 
      incCam(0,20);
    }
    if (keyCode==DOWN) { 
      incCam(0,-20);
    }
    if (keyCode==LEFT) { 
      incCam(-20,0);
    }
    if (keyCode==RIGHT) { 
      incCam(20,0);
    }
    if (keyCode==CONTROL) {
      setAngle(true);
    }
    if (keyCode==33) {
      ro-=50;
      if (ro<50) ro=50;
    }
    if (keyCode==34) {
      ro+=50;
      if (ro>15000) ro=15000;
    }
  }
  else
  {
    //if (key=='s') 
    //  for (int i=0; i<Npil; i++) p[i].incS(-0.1);      // inclinacao da tampa
    //if (key=='w') 
    //  for (int i=0; i<Npil; i++) p[i].incS(0.1);
    //if (key==' ') 
    //  for (int i=0; i<Npil; i++) p[i].setS(0,0);         
    //if (key=='a') 
    //  for (int i=0; i<Npil; i++) p[i].incR(-0.1);        // angulo de rotacao
    //if (key=='d') 
    //  for (int i=0; i<Npil; i++) p[i].incR(0.1);    
    //if (key=='q') 
    //  for (int i=0; i<Npil; i++) p[i].incL(-5);          // largura do pilindro
    //if (key=='e') 
    //  for (int i=0; i<Npil; i++) p[i].incL(5);
    if (key=='/')
      setAngle(true);

    if (key=='1')
      lid=1;
    if (key=='2')
      lid=2;

    if (key==' ') {
      credits.unSelect();
      teoria.unSelect();
      controls.unSelect();
      controlst.unSelect();
    }
  }

  dd=2;
  loop();
}

void mouseWheel(int delta) 
{
  ro+=50*delta;
  if (ro<50) ro=50;
  dd=2;
  loop();
}

